package com.javacodegeeks.helidon.reservation;

import java.util.Collection;

import javax.enterprise.context.ApplicationScoped;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

import org.dom4j.DocumentFactory;

@ApplicationScoped
public class ReservationRepository { 
    @PersistenceContext(unitName = "reservations-db")
    private EntityManager entityManager;
    
    static {
        DocumentFactory.getInstance();
    }

    public ReservationEntity save(ReservationEntity reservation) {
        entityManager.persist(reservation);
        return reservation;
    }

    public Collection<ReservationEntity> findAll() {
        final CriteriaBuilder cb = entityManager.getCriteriaBuilder();
        final CriteriaQuery<ReservationEntity> cq = cb.createQuery(ReservationEntity.class);
        final Root<ReservationEntity> root = cq.from(ReservationEntity.class);
        final CriteriaQuery<ReservationEntity> all = cq.select(root);
        return entityManager.createQuery(all).getResultList();
    }
}
