package com.javacodegeeks.micronaut.reservation;

import java.time.OffsetDateTime;
import java.util.UUID;

import javax.validation.constraints.FutureOrPresent;
import javax.validation.constraints.NotNull;

import io.micronaut.core.annotation.Introspected;

@Introspected
public class CreateReservation {
    @NotNull UUID vehicleId;
    @NotNull @FutureOrPresent OffsetDateTime from;
    @NotNull @FutureOrPresent OffsetDateTime to;
    
    public UUID getVehicleId() {
        return vehicleId;
    }
    
    public void setVehicleId(UUID vehicleId) {
        this.vehicleId = vehicleId;
    }

    public OffsetDateTime getFrom() {
        return from;
    }

    public void setFrom(OffsetDateTime from) {
        this.from = from;
    }

    public OffsetDateTime getTo() {
        return to;
    }

    public void setTo(OffsetDateTime to) {
        this.to = to;
    }
    
    public CreateReservation withVehicleId(UUID vehicleId) {
        setVehicleId(vehicleId);
        return this;
    }
    
    public CreateReservation withFrom(OffsetDateTime from) {
        setFrom(from);
        return this;
    }
    
    public CreateReservation withTo(OffsetDateTime to) {
        setTo(to);
        return this;
    }
}
