package com.javacodegeeks.micronaut.reservation;

import java.util.Collection;

import javax.inject.Inject;
import javax.validation.Valid;

import io.micronaut.http.HttpStatus;
import io.micronaut.http.annotation.Body;
import io.micronaut.http.annotation.Controller;
import io.micronaut.http.annotation.Get;
import io.micronaut.http.annotation.Post;
import io.micronaut.http.annotation.Status;
import io.micronaut.validation.Validated;

@Validated
@Controller("/api/reservations")
public class ReservationController {
    private final ReservationService reservationService;
    
    @Inject
    public ReservationController(ReservationService reservationService) {
        this.reservationService = reservationService;
    }

    @Get
    public Collection<Reservation> list() {
        return reservationService.reservations();
    }
    
    @Post
    @Status(HttpStatus.CREATED)
    public Reservation reserve(@Body @Valid CreateReservation payload) {
        return reservationService.reserve(payload);
    }
}
