package com.javacodegeeks.quarkus.reservation;

import java.util.Collection;

import javax.inject.Inject;
import javax.validation.Valid;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.UriInfo;

@Path("/api/reservations")
public class ReservationResource {
    private final ReservationService reservationService;
    
    @Inject
    public ReservationResource(ReservationService reservationService) {
        this.reservationService = reservationService;
    }

    @GET
    @Produces(MediaType.APPLICATION_JSON)
    public Collection<Reservation> list() {
        return reservationService.reservations();
    }
    
    @POST
    @Consumes(MediaType.APPLICATION_JSON)
    @Produces(MediaType.APPLICATION_JSON)
    public Response reserve(@Valid CreateReservation payload, @Context UriInfo uri) {
        final Reservation reservation = reservationService.reserve(payload);
        return Response
            .created(uri.getRequestUriBuilder().path(reservation.getId().toString()).build())
            .entity(reservation).build();
    }
}
