Spring Native Demo Service with GraalVM
===

1. Please install GraalVM 20.3.1: `https://github.com/graalvm/graalvm-ce-builds/releases/tag/vm-20.3.1`
2. Run MySQL instance: `docker run -d -p 3306:3306 -e MYSQL_DATABASE=reservations_db -e MYSQL_USER=reservations -e MYSQL_PASSWORD=passw0rd -e MYSQL_ROOT_PASSWORD=passw0rd -d mysql:8 --character-set-server=utf8mb4 --collation-server=utf8mb4_unicode_ci`
3. Build native image: `mvn clean package -Pnative-image`
4. Run native executable:
    
    On Linux: `$ ./target/spring-reservation`
     
    On Windows: `$ .\target\spring-reservation.exe` 

5. Get all reservations: 

```
     curl http://localhost:8080/api/reservations
```

6. Create a new reservations: 

```
curl -X POST http://localhost:8080/api/reservations 
   -H "Content-Type: application/json" 
   -d '{
     "vehicleId": "07a6962a-723c-4fe2-8b64-5ac68f4f4b6f", 
     "from": "2025-01-20T00:00:00.000000000-05:00",
     "to": "2025-01-25T23:59:59.000000000-05:00"
    }'
```