package com.javacodegeeks.spring.reservation;


import java.time.OffsetDateTime;
import java.util.UUID;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;

@Entity
@Table(name = "reservations")
public class ReservationEntity {
    @Id
    private UUID id;

    @Column(name = "vehicle_id")
    private UUID vehicleId;
    
    @Column(name = "date_from")
    private OffsetDateTime from;
    
    @Column(name = "date_to")
    private OffsetDateTime to;
    
    @Column(name = "status")
    private String status;
    
    public ReservationEntity() {
    }
    
    public ReservationEntity(UUID id, UUID vehicleId) {
        this.id = id;
        this.vehicleId = vehicleId;
    }

    public OffsetDateTime getFrom() {
        return from;
    }

    public void setFrom(OffsetDateTime from) {
        this.from = from;
    }

    public OffsetDateTime getTo() {
        return to;
    }

    public void setTo(OffsetDateTime to) {
        this.to = to;
    }

    public Status getStatus() {
        return Status.valueOf(status);
    }

    public void setStatus(Status status) {
        this.status = status.name();
    }
    
    public UUID getVehicleId() {
        return vehicleId;
    }
    
    public void setVehicleId(UUID vehicleId) {
        this.vehicleId = vehicleId;
    }
    
    public UUID getId() {
        return id;
    }
    
    public void setId(UUID id) {
        this.id = id;
    }
}
